jQuery( function ( $ ) {
	// Customer notes
	$( '#wc_customers_notes' )
		.on( 'click', 'a.add_customer_note', function() {
			if ( ! $( 'textarea#add_customer_note' ).val() ) {
				return;
			}

			$( '#wc_customers_notes' ).block({
				message: null,
				overlayCSS: {
					background: '#fff url(' + wpo_wccm.plugin_url + 'images/ajax-loader.gif) no-repeat center',
					opacity: 0.6
				}
			});

			var data = {
				action:    'wc_customers_add_customer_note',
				post_id:   wpo_wccm.post_id,
				note:      $( 'textarea#add_customer_note' ).val(),
				security:  wpo_wccm.add_customer_note_nonce,
			};

			$.post( wpo_wccm.ajax_url, data, function( response ) {
				$( 'ul.customer_notes' ).prepend( response );
				$( '#wc_customers_notes' ).unblock();
				$( '#add_customer_note' ).val( '' );
			});

			return false;

		})
		.on( 'click', 'a.delete_note', function() {
			var note = $( this ).closest( 'li.note' );

			$( note ).block({
				message: null,
				overlayCSS: {
					background: '#fff url(' + wpo_wccm.plugin_url + 'images/ajax-loader.gif) no-repeat center',
					opacity: 0.6
				}
			});

			var data = {
				action:   'wc_customers_delete_customer_note',
				note_id:  $( note ).attr( 'rel' ),
				security: wpo_wccm.delete_customer_note_nonce,
			};

			$.post( wpo_wccm.ajax_url, data, function( response ) {
				$( note ).remove();
			});

			return false;
		});

	$( '#wc_customers_address' )
		.on( 'click', 'a.save-customer-number', function() {
			$( 'span.customer-number' ).block({
				message: null,
				overlayCSS: {
					background: '#fff url(' + wpo_wccm.plugin_url + 'images/ajax-loader.gif) no-repeat center',
					opacity: 0.6
				}
			});

			var data = {
				action:           'wc_customers_save_customer_number',
				post_id:          wpo_wccm.post_id,
				customer_number:  $( '.customer-number-input' ).val(),
				original_number:  $( '.customer-number-input' ).data().original,
				security:         wpo_wccm.save_customer_number_nonce,
			};

			$.post( wpo_wccm.ajax_url, data, function( response ) {
				$( 'span.customer-number' ).unblock();
				$( '.customer-number-input' ).attr( 'data-original', data.customer_number )
				// alert( response );
			});
		});

	// enable customer card when user clicks (to prevent new post issues!)
	$( '#wc_customers_card' ).click( function ( event ) {
		if ( $( '.wccm_disabled' ).prop( "disabled" ) ) {
			$( '.wccm_disabled' ).prop( "disabled", false );
		}
		
	});
});
